{{ self.title() }}

{{ _('Description') }}

卷积 (Convolution)，是一种被广泛应用于信号处理，图像处理，深度学习等领域的一种基础操作。在本题中，我们主要关注二维卷积的计算。二维卷积的计算过程如下图所示：

{{ img('1.jpg', size = 0.8, align = 'middle') }}

在本题中，我们要求计算二维卷积的一个简化版本，要计算个特殊的 $N \times N$ 的二维卷积。**[REVIEW: 能否直接说“我们要求计算一个特殊的 $N \times N$ 的二维卷积”]** 给定一个大小为 $(H + N - 1) \times (W + N - 1)$ 的矩阵，经过计算后得到一个 $H \times W$ 的矩阵，该矩阵的每一个元素都是原矩阵以该点为左上角的 $N \times N$ 的正方形的值的平均值。

**【REVIEW: 这里也给个图说明？】**

{{ _('Input Format') }}
输入为大小为 $(W + N - 1) \times (H + N - 1)$ 的内存中的浮点矩阵**【REVIEW: 单精度，以及矩阵的排列方式？，和前面题目的描述反的，之前H在前】**。其中 $W (1 \le W \le 10000), H (1 \le H \le 10000), N (2 \le N \le 10)$

为了方便运算，$W$ 和 $H$ 都是8的整数倍。

{{ _('Scoring') }}

$100$ = $10$（正确性）+ $90$（全场性能评比）

$10$ 分为正确性得分：总共 $10$ 输入文件，每个文件为 $1$ 分。

$90$ 分为性能评比得分：每个测试点满分为 $9$ 分，只有当选手得到正确性得分后才能得到性能分。设 $t_{\max}$ 为所有选手本测试点的用时 $t$ 的最大值，该测试点的性能得分为：
$$
9\times \frac{t}{t_{\max}}
$$


## C/C++ 解题框架

你需要在 `solve.c` 中实现 `solve()` 函数。

具体的，在所给的框架中，包含以下一些文件/文件夹：

* `Makefile`：用于编译，生成可执行文件，并执行测试。运行 `make test` 来执行测试。
* `solve.c`：你所需要填写的代码文件，提交时仅能提交该文件。**[REVIEW: 感觉需要说明参数，比如output实际是已经分配好的空间，只需要修改值即可]**
   * 你需要实现 `solve()` 函数。
   * 你可以在该文件中添加你可能要用到的变量、函数和其他代码。
* `simd.h`：CPU的 SIMD指令的封装。
* `solve.h`：`solve()` 函数声明。
* `main.c`：主函数，包括数据生成等逻辑。

**【REVIEW: 这里感觉可以加一个图片简单示例下正确/错误情况的输出】**

## {{ _('Hint') }}

1. 选手可以使用多线程来加速程序的性能。
2. 选手可以使用 CPU 的向量指令来加速程序性能，simd.h 文件里包含了选手可能使用的一些向量指令的封装。**【REVIEW: 这里感觉可以给个具体的函数说明？】**
